# Tag parent 1 and 2
tag @e[type=horse, distance=..10, scores={baa.horse_breed.age=5995..6005}, limit=1, sort=nearest] add horse_breed.parent_1
tag @e[type=donkey, distance=..10, scores={baa.horse_breed.age=5995..6005}, limit=1, sort=nearest] add horse_breed.parent_2

execute unless entity @e[tag=horse_breed.parent_1, distance=..10] run tag @e[type=horse, limit=1, sort=nearest] add horse_breed.parent_1
execute unless entity @e[tag=horse_breed.parent_2, distance=..10] run tag @e[type=donkey, limit=1, sort=nearest] add horse_breed.parent_2

# Store stats of parent 1 (x1000000)
execute store result score h1 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.max_health get 1000000
execute store result score s1 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.movement_speed get 1000000
execute store result score j1 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] horse.jump_strength get 1000000
execute store result score a1 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.armor get 1000000
execute store result score at1 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.armor_toughness get 1000000
execute store result score kb1 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.knockback_resistance get 1000000

# Store stats of parent 2 (x1000000)
execute store result score h2 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_2, limit=1, sort=nearest] generic.max_health get 1000000
execute store result score s2 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_2, limit=1, sort=nearest] generic.movement_speed get 1000000
execute store result score j2 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_2, limit=1, sort=nearest] horse.jump_strength get 1000000
execute store result score a2 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.armor get 1000000
execute store result score at2 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.armor_toughness get 1000000
execute store result score kb2 baa.horse_breed.stat run attribute @e[tag=horse_breed.parent_1, limit=1, sort=nearest] generic.knockback_resistance get 1000000

#tellraw @a ["",{"text":"Mother: "},{"score":{"name":"h1","objective":"baa.horse_breed.stat"}}]
#tellraw @a ["",{"text":"Father: "},{"score":{"name":"h2","objective":"baa.horse_breed.stat"}}]

# Find average stats
scoreboard players operation h1 baa.horse_breed.stat += h2 baa.horse_breed.stat
scoreboard players operation s1 baa.horse_breed.stat += s2 baa.horse_breed.stat
scoreboard players operation j1 baa.horse_breed.stat += j2 baa.horse_breed.stat
scoreboard players operation a1 baa.horse_breed.stat += a2 baa.horse_breed.stat
scoreboard players operation at1 baa.horse_breed.stat += at2 baa.horse_breed.stat
scoreboard players operation kb1 baa.horse_breed.stat += kb2 baa.horse_breed.stat
scoreboard players operation h1 baa.horse_breed.stat /= 2 baa.const
scoreboard players operation s1 baa.horse_breed.stat /= 2 baa.const
scoreboard players operation j1 baa.horse_breed.stat /= 2 baa.const
scoreboard players operation a1 baa.horse_breed.stat /= 2 baa.const
scoreboard players operation at1 baa.horse_breed.stat /= 2 baa.const
scoreboard players operation kb1 baa.horse_breed.stat /= 2 baa.const

# Find difference in parent values (x0.5)
scoreboard players operation h2 baa.horse_breed.stat -= h1 baa.horse_breed.stat
scoreboard players operation s2 baa.horse_breed.stat -= s1 baa.horse_breed.stat
scoreboard players operation j2 baa.horse_breed.stat -= j1 baa.horse_breed.stat
scoreboard players operation a2 baa.horse_breed.stat -= a1 baa.horse_breed.stat
scoreboard players operation at2 baa.horse_breed.stat -= at1 baa.horse_breed.stat
scoreboard players operation kb2 baa.horse_breed.stat -= kb1 baa.horse_breed.stat
execute if score h2 baa.horse_breed.stat matches ..-1 run scoreboard players operation h2 baa.horse_breed.stat *= -1 baa.const
execute if score s2 baa.horse_breed.stat matches ..-1 run scoreboard players operation s2 baa.horse_breed.stat *= -1 baa.const
execute if score j2 baa.horse_breed.stat matches ..-1 run scoreboard players operation j2 baa.horse_breed.stat *= -1 baa.const
execute if score a2 baa.horse_breed.stat matches ..-1 run scoreboard players operation a2 baa.horse_breed.stat *= -1 baa.const
execute if score at2 baa.horse_breed.stat matches ..-1 run scoreboard players operation at2 baa.horse_breed.stat *= -1 baa.const
execute if score kb2 baa.horse_breed.stat matches ..-1 run scoreboard players operation kb2 baa.horse_breed.stat *= -1 baa.const

# Calculate 'base deviation', the closer the average stat is to MIN or MAX the smaller the deviation will be
# Formula: (2*sigma - |mu-x|)/5
scoreboard players set h0 baa.horse_breed.stat 22500000
scoreboard players set s0 baa.horse_breed.stat 200000
scoreboard players set j0 baa.horse_breed.stat 650000

scoreboard players operation h0 baa.horse_breed.stat -= h1 baa.horse_breed.stat
scoreboard players operation s0 baa.horse_breed.stat -= s1 baa.horse_breed.stat
scoreboard players operation j0 baa.horse_breed.stat -= j1 baa.horse_breed.stat

execute if score h0 baa.horse_breed.stat matches 1.. run scoreboard players operation h0 baa.horse_breed.stat *= -1 baa.const
execute if score s0 baa.horse_breed.stat matches 1.. run scoreboard players operation s0 baa.horse_breed.stat *= -1 baa.const
execute if score j0 baa.horse_breed.stat matches 1.. run scoreboard players operation j0 baa.horse_breed.stat *= -1 baa.const

scoreboard players add h0 baa.horse_breed.stat 15000000
scoreboard players add s0 baa.horse_breed.stat 187500
scoreboard players add j0 baa.horse_breed.stat 500000

scoreboard players operation h0 baa.horse_breed.stat /= 5 baa.const
scoreboard players operation s0 baa.horse_breed.stat /= 5 baa.const
scoreboard players operation j0 baa.horse_breed.stat /= 5 baa.const

#tellraw @a ["",{"text":"Base deviation: "},{"score":{"name":"h0","objective":"baa.horse_breed.stat"}}]

# Total deviation is base deviation + half of difference in parent values
scoreboard players operation h2 baa.horse_breed.stat += h0 baa.horse_breed.stat
scoreboard players operation s2 baa.horse_breed.stat += s0 baa.horse_breed.stat
scoreboard players operation j2 baa.horse_breed.stat += j0 baa.horse_breed.stat

#tellraw @a ["",{"text":"Deviation: "},{"score":{"name":"h2","objective":"baa.horse_breed.stat"}}]

# Calculate 6 random values between 0 and 100
summon minecraft:marker ~ ~ ~ {Tags:["rand_uuid_1"]}
summon minecraft:marker ~ ~ ~ {Tags:["rand_uuid_2"]}
execute store result score r1 baa.horse_breed.stat run data get entity @e[tag=rand_uuid_1, limit=1, sort=nearest] UUID[0]
execute store result score r2 baa.horse_breed.stat run data get entity @e[tag=rand_uuid_1, limit=1, sort=nearest] UUID[1]
execute store result score r3 baa.horse_breed.stat run data get entity @e[tag=rand_uuid_1, limit=1, sort=nearest] UUID[2]
execute store result score r4 baa.horse_breed.stat run data get entity @e[tag=rand_uuid_2, limit=1, sort=nearest] UUID[0]
execute store result score r5 baa.horse_breed.stat run data get entity @e[tag=rand_uuid_2, limit=1, sort=nearest] UUID[1]
execute store result score r6 baa.horse_breed.stat run data get entity @e[tag=rand_uuid_2, limit=1, sort=nearest] UUID[2]
scoreboard players operation r1 baa.horse_breed.stat %= 101 baa.const
scoreboard players operation r2 baa.horse_breed.stat %= 101 baa.const
scoreboard players operation r3 baa.horse_breed.stat %= 101 baa.const
scoreboard players operation r4 baa.horse_breed.stat %= 101 baa.const
scoreboard players operation r5 baa.horse_breed.stat %= 101 baa.const
scoreboard players operation r6 baa.horse_breed.stat %= 101 baa.const
kill @e[tag=rand_uuid_1]
kill @e[tag=rand_uuid_2]

# Create 3 random numbers in [-100,100] (triangle distribution)
scoreboard players operation r1 baa.horse_breed.stat -= r4 baa.horse_breed.stat
scoreboard players operation r2 baa.horse_breed.stat -= r5 baa.horse_breed.stat
scoreboard players operation r3 baa.horse_breed.stat -= r6 baa.horse_breed.stat

#tellraw @a ["",{"text":"r1: "},{"score":{"name":"r1","objective":"baa.horse_breed.stat"}}]

# Multiply deviation with random numbers
scoreboard players operation h2 baa.horse_breed.stat *= r1 baa.horse_breed.stat
scoreboard players operation s2 baa.horse_breed.stat *= r2 baa.horse_breed.stat
scoreboard players operation j2 baa.horse_breed.stat *= r3 baa.horse_breed.stat
scoreboard players operation h2 baa.horse_breed.stat /= 100 baa.const
scoreboard players operation s2 baa.horse_breed.stat /= 100 baa.const
scoreboard players operation j2 baa.horse_breed.stat /= 100 baa.const

# Add random deviation to average
scoreboard players operation h1 baa.horse_breed.stat += h2 baa.horse_breed.stat
scoreboard players operation s1 baa.horse_breed.stat += s2 baa.horse_breed.stat
scoreboard players operation j1 baa.horse_breed.stat += j2 baa.horse_breed.stat

#tellraw @a ["",{"text":"Final score: "},{"score":{"name":"h1","objective":"baa.horse_breed.stat"}}]

# Save stats to foal (x0.000001)
execute store result entity @s Attributes[{Name:"minecraft:generic.max_health"}].Base float 0.000001 run scoreboard players get h1 baa.horse_breed.stat
execute store result entity @s Attributes[{Name:"minecraft:generic.movement_speed"}].Base float 0.000001 run scoreboard players get s1 baa.horse_breed.stat
execute store result entity @s Attributes[{Name:"minecraft:horse.jump_strength"}].Base float 0.000001 run scoreboard players get j1 baa.horse_breed.stat
execute store result entity @s Attributes[{Name:"minecraft:generic.armor"}].Base float 0.000001 run scoreboard players get a1 baa.horse_breed.stat
execute store result entity @s Attributes[{Name:"minecraft:generic.armor_toughness"}].Base float 0.000001 run scoreboard players get at1 baa.horse_breed.stat
execute store result entity @s Attributes[{Name:"minecraft:generic.knockback_resistance"}].Base float 0.000001 run scoreboard players get kb1 baa.horse_breed.stat


# Cleanup scores and tags
scoreboard players reset h0 baa.horse_breed.stat
scoreboard players reset s0 baa.horse_breed.stat
scoreboard players reset j0 baa.horse_breed.stat

scoreboard players reset h1 baa.horse_breed.stat
scoreboard players reset s1 baa.horse_breed.stat
scoreboard players reset j1 baa.horse_breed.stat
scoreboard players reset a1 baa.horse_breed.stat
scoreboard players reset at1 baa.horse_breed.stat
scoreboard players reset kb1 baa.horse_breed.stat

scoreboard players reset h2 baa.horse_breed.stat
scoreboard players reset s2 baa.horse_breed.stat
scoreboard players reset j2 baa.horse_breed.stat
scoreboard players reset a2 baa.horse_breed.stat
scoreboard players reset at2 baa.horse_breed.stat
scoreboard players reset kb2 baa.horse_breed.stat

scoreboard players reset r1 baa.horse_breed.stat
scoreboard players reset r2 baa.horse_breed.stat
scoreboard players reset r3 baa.horse_breed.stat
scoreboard players reset r4 baa.horse_breed.stat
scoreboard players reset r5 baa.horse_breed.stat
scoreboard players reset r6 baa.horse_breed.stat

tag @s remove horse_breed.foal
tag @e remove horse_breed.parent_1
tag @e remove horse_breed.parent_2
