effect give @a[tag=transform] water_breathing 1 0 true
effect give @a[tag=transform] weakness 1 255 true
execute if entity @a[tag=born,tag=cart] run execute at @e[type=item_display,tag=body,tag=cart,tag=born] run particle minecraft:dust 1.000 0.788 0.212 2 ~ ~ ~ 3 3 3 0 400 force
execute if entity @a[tag=born,tag=cart] run execute at @e[type=item_display,tag=body,tag=cart,tag=born] run particle minecraft:dust 1.000 0.639 0.098 2 ~ ~ ~ 3 3 3 0 400 force

execute as @a unless score @s baa.change-config matches -2147483648..2147483647 run scoreboard players set @s baa.change-config 0

#Tick
function baa:vehicles/tick

#Horses
execute if score horse_mutations baa.config matches 1 run function baa:horses/tick

#Config
execute as @a unless score @s baa.change-config matches 0 run function baa:api/config/modify

#Cooldowns
execute as @a unless score @s baa.claw_swipe_cd matches -2147483648..2147483647 run scoreboard players set @s baa.claw_swipe_cd 0
execute as @a unless score @s baa.roar_cd matches -2147483648..2147483647 run scoreboard players set @s baa.roar_cd 0
execute as @a unless score @s baa.claw_swipe_cd matches 0 run scoreboard players remove @s baa.claw_swipe_cd 1
execute as @a unless score @s baa.roar_cd matches 0 run scoreboard players remove @s baa.roar_cd 1

#Dino Costume Roar Ability
execute as @a[tag=roar_ready,predicate=snc:is_sneaking,predicate=baa:costumes/dino_costume/brown/head,predicate=baa:costumes/dino_costume/brown/chest,predicate=baa:costumes/dino_costume/brown/legs,predicate=baa:costumes/dino_costume/brown/feet,scores={baa.roar_cd=0}] at @s run function baa:costumes/dinosaur/roar
execute as @a[tag=roar_ready,predicate=snc:is_sneaking,predicate=baa:costumes/dino_costume/green/head,predicate=baa:costumes/dino_costume/green/chest,predicate=baa:costumes/dino_costume/green/legs,predicate=baa:costumes/dino_costume/green/feet,scores={baa.roar_cd=0}] at @s run function baa:costumes/dinosaur/roar
execute as @a unless predicate snc:is_sneaking run tag @s add roar_ready

#Smelting
execute as @a at @s if score @s baa.furnace_place matches 1.. anchored eyes positioned ^ ^ ^ run function baa:smelting_recipes/detect_furnace
execute as @a at @s if score @s baa.blast_furnace_place matches 1.. anchored eyes positioned ^ ^ ^ run function baa:smelting_recipes/detect_furnace
execute as @a at @s if score @s baa.smoker_place matches 1.. anchored eyes positioned ^ ^ ^ run function baa:smelting_recipes/detect_furnace
execute as @a at @s if score @s baa.furnace_interact matches 1.. anchored eyes positioned ^ ^ ^ run function baa:smelting_recipes/detect_furnace
execute as @a at @s if score @s baa.blast_furnace_interact matches 1.. anchored eyes positioned ^ ^ ^ run function baa:smelting_recipes/detect_furnace
execute as @a at @s if score @s baa.smoker_interact matches 1.. anchored eyes positioned ^ ^ ^ run function baa:smelting_recipes/detect_furnace
function baa:smelting_recipes/detect_smelted

#Intelligience
execute as @e[type=#snc:eldian] unless score @s baa.intelligence matches -2147483648..2147483647 run function baa:research/intelligence

#Research Table
execute as @e[type=item_display,tag=baa.research_table] at @s run function baa:research/table/tick

#Bookshelves
execute as @e[type=marker,tag=baa.chiseled_bookshelf] at @s run function baa:research/bookshelf/tick

#Clear Illegal Items
kill @e[type=item,nbt={Item:{tag:{baa:illegal}}}]
clear @a minecraft:gray_dye{baa:illegal}
clear @a paper{baa:illegal,baa.research:how_to}

#Witniss a Titan
execute as @a[tag=!baa.seen_titan] at @s if entity @e[tag=titan,distance=..20] run title @s actionbar {"text":"You have observed the horrific might of a titan. Maybe you can find a way to defeat one?","italic":true,"color":"dark_purple"}
execute as @a[tag=!baa.seen_titan] at @s if entity @e[tag=titan,distance=..20] run tag @s add baa.seen_titan